Redmine - Patch #3358

Advanced LDAP authentication
2009-05-13 21:24 - Daniel Marczisovszky

Status: New Start date: 2009-05-13
Priority: Normal Due date:

Assignee: % Done: 0%
Category: LDAP Estimated time: 0.00 hour
Target version: Candidate for next major release

Description

This patch adds the following new features to LDAP authentication:

using dereferencing aliases on search

ability to select protocol LDAPv2 or LDAPv3

connect using STARTTLS

selecting server certificate validation level

user-definable custom search filter

bind as current user instead of admin account, see Feature #1913

searching is sub-tree by default, in future GUI option may be added to configure this

If custom search filter is used, $login is replaced with the username. For example, to search for users with objectClass posixAccount,

use this filter string: @(&(uid=$login)(objectClass=posixAccount))

Note that this patch uses Ruby/LDAP instead of Net::LDAP, so this should be installed, for example on Debian, use apt-get install

libldap-ruby1.8

After applying this patch, run rake db:migrate RAILS_ENV="production", as auth_sources table is modified in the database. (filter,

dereference, starttls, require_cert and protocol_version columns are added)

Related issues:
Related to Redmine - Defect #3253: LDAP Auth : Alias Dereference
Related to Redmine - Patch #29606: Support self-signed LDAPS connections

New 2009-04-28
Closed

History

#1 - 2009-07-09 14:08 - Felix Schéafer

Hello,
Are there any plans to integrate this or something similar to the next redmine release?

Thanks!

#2 - 2009-07-13 22:54 - Jérémy Lal

Hi,

i tried your patch against current trunk, and it doesn't work very well :
using a working set of params for creating an Idap authentication mode,
with redmine trunk the "Test" button works ok,

and with your patch i get that log :

Connecting to localhost:389, tls=false

Dereference set option

Trying to bind

Bind as user admin

LDAP Connect Error: Invalid DN syntax

The actual parameters are very simple :
host: localhost

account: admin

password: admin

Base DN: dc=localhost

andiset:

login: cn

firstname: givenName
lastname: sn
email: mail

of course the Idap objects have those four non-empty attributes

#3 - 2009-07-13 23:03 - Jérémy Lal

oops, sorry, actually it's the redmine trunk that wrongly reports the connection succeeds
i guess i'm not used to Idap ;)

#4 - 2009-07-13 23:58 - Jérémy Lal

ok, it works, my mistake.

Thanks !

The db migration maybe is screwing existing Idap authentication modes,
for example i had to re-enter "Account” field to get it working.

| hope that patch makes its way to trunk,

since dropping old ruby-net-ldap plugin seems a very good idea,
and your patch looks clean and simple.

#5 - 2009-07-14 14:37 - Jérémy Lal
- File 07 _Ildap_update.patch added

Here's a patch to be applied over yours, that adds Idap synchronisation for "firstname, lastname, mail" attributes.
When one user changes these attributes using "My account" page, it updates them in Idap.

| thought it is logical to keep those three attributes synchronised ?

Maybe the auth_source should offer an option for this ?

#6 - 2009-07-14 16:29 - Jérémy Lal
- File 07 _Ildap_sync.patch added

This improved patch synchronises "firstname, lastname, mail" from LDAP to DB at login,
and from DB to LDAP when user changes his attributes.

#7 - 2009-07-14 16:56 - Felix Schéfer
Jérémy Lal wrote:
This improved patch synchronises "firstname, lastname, mail" from LDAP to DB at login,

and from DB to LDAP when user changes his attributes.

Looks good, but at least in the admin view, | don't see changes | made to another user on the LDAP backend... Can you confirm it works for you?
#8 - 2009-07-14 18:38 - Daniel Marczisovszky
Felix Schéafer wrote:

Hello,

Are there any plans to integrate this or something similar to the next redmine release?

Thanks!

I've tried to contact Jean-Philippe Lang two months ago, however | received no response yet. I'll update this patch to 0.8.4 soon. (Maybe to the
current trunk as well.)

#9 - 2009-07-14 18:41 - Daniel Marczisovszky
Jérémy Lal wrote:
| thought it is logical to keep those three attributes synchronised ?

Maybe the auth_source should offer an option for this ?

Yes, it is logical, however there are many cases where there is no option to modify the LDAP. So | think there should be a checkbox on the LDAP
auth source configuration page which tells if update is allowed or not. I've not tried your patch yet, just looked at the source, but for me it seems there
is no way to disable this feature.

#10 - 2009-07-14 19:16 - Felix Schéfer
Daniel Marczisovszky wrote:
Felix Schéafer wrote:

Are there any plans to integrate this or something similar to the next redmine release?

I've tried to contact Jean-Philippe Lang two months ago, however | received no response yet. I'll update this patch to 0.8.4 soon. (Maybe to the
current trunk as well.)

works fine for me so far (against current trunk).

#11 - 2009-07-19 02:27 - Eric Davis

Does anyone know a quick tutorial to setup an LDAP server to test this on? If | can get one running locally, | can review this patch (and #3253) and
see about fixing this issue.

#12 - 2009-07-19 12:25 - Daniel Marczisovszky
Eric Davis wrote:

Does anyone know a quick tutorial to setup an LDAP server to test this on? If | can get one running locally, | can review this patch (and #3253)
and see about fixing this issue.

| can write a tutorial for you, but please tell which operating system are you using. Maybe | can set up a public test LDAP server, but | have to look for
an available machine :)

#13 - 2009-07-19 15:24 - Felix Schéfer

Jérémy Lal wrote:

This improved patch synchronises "firstname, lastname, mail" from LDAP to DB at login,
and from DB to LDAP when user changes his attributes.

The patch redefines the "update" method for app/models/auth_source_ldap.rb , which ultimately breaks saving of an LDAP auth source, because
ActiveRecord already has an update attribute, see http://api.rubyonrails.org/classes/ActiveRecord/Base.html#M002560 . | have renamed the method
to update_user and changed (my patched) app/controllers/my_controller.rb accordingly. Another thing I'd like to see here: the logic to chose between
updating the user attributes to the DB or to LDAP should be done in the user model, not the user controller, | haven't looked deep enough if the actual
LDAP code should stay in the auth_source or go in the user model too, but | might do once I'm through with my exam next week.

Another thing that goes wrong in the patch: | haven't tested if it works well without a filter, but | think it would be the same: you provide
ldap_con.modify with something akin to an LDAP search string, where it awaits a DN, so you need to do an LDAP search with the search filter you
create and feed the result do Idap_con.modify.

What I'd really like now is some more LDAP integration, like custom user fields populated by LDAP attributes, and user groups in redmine mapped to
the LDAP groups, that would be even better :-)

#14 - 2009-07-19 20:39 - Eric Davis
Daniel Marczisovszky wrote:
| can write a tutorial for you, but please tell which operating system are you using. Maybe | can set up a public test LDAP server, but | have to

look for an available machine :)

Debian Linux would be best, Ubuntu would be ok.
#15 - 2009-07-21 23:52 - Daniel Marczisovszky
Eric Davis wrote:

Debian Linux would be best, Ubuntu would be ok.

apt-get install slapd

It will ask for your administrator password
You have to confirm the password

Ok, OpenLDAP is installed.

Your default base DN will be your domain name, for example if
your FQDN is Idap.redmine.org then your base of the LDAP directory will be:
dc=redmine,dc=org

Your default user is:
cn=admin,dc=redmine,dc=org
(use the password specified during the install)

apt-get install Idap-utils

To search in your LDAP:
@ldapsearch -b dc=redmine,dc=org -x -D cn=admin,dc=redmine,dc=org -W objectClass="

| usually use this small Java based GUI tool to manage LDAP:
http://www.brothersoft.com/Idap-browser-download-14779.html

| can create a sample LDAP tree that you can import into yours. Moreover (as | created this test machine in VMWare) | can send you the virtual
machine.

#16 - 2009-08-21 15:47 - Adi Kriegisch

| added a patch to redmine/extra/svn/Redmine.pm (apache auth source for svn server) to honor my (#1913) LDAP modifications. It might be a good
idea to add your features to this tool as well... :-) [hitp://www.redmine.org/attachments/2454/Redmine-ldap-as-user.diff]

Another thing: Did you consider implementing search scope selection? To me this is a showstopper as | need to have a scope of "one"... :-(
#17 - 2009-08-22 10:36 - Daniel Marczisovszky
Adi Kriegisch wrote:
| added a patch to redmine/extra/svn/Redmine.pm (apache auth source for svn server) to honor my (#1913) LDAP modifications. It might be a

good idea to add your features to this tool as well... :-) [http://www.redmine.org/attachments/2454/Redmine-ldap-as-user.diff]

I'm afraid | can not add these, even I'm not using SVN integration for Redmine. However, | can help to create to common class/codebase to make
these LDAP features available to these modules/patches.

Another thing: Did you consider implementing search scope selection? To me this is a showstopper as | need to have a scope of "one"... :-(

Noone was interested till now ;) but | will add this (hopefully) within a week.

#18 - 2009-08-25 00:31 - Florian Collot
- % Done changed from 100 to 0

I'vimplement the patch Idap_update to my redmine release but when submiting user informations, i got an internal error.
Do you know this problem ?

#19 - 2009-08-25 00:33 - Florian Collot
- % Done changed from 0 to 90

#20 - 2009-08-25 00:56 - Florian Collot
Florian Collot wrote:
I'vimplement the patch Idap_update to my redmine release but when submiting user informations, i got an internal error.

Do you know this problem ?

I've renamed @user.auth_source.update to update_user in the model and the controller, so i have no more Internal Error, and when submiting, i got a
redmine success. But, my Idap entry is not updated. What's wrong ?

#21 - 2009-08-25 01:02 - Felix Schéfer
Florian Collot wrote:
I've renamed @user.auth_source.update to update_user in the model and the controller, so i have no more Internal Error, and when submiting, i

got a redmine success. But, my Idap entry is not updated. What's wrong ?

| think you got it backwards.Vanilla Redmine fetches information from LDAP only to populate some or all of the fields of a user at creation time, the
patch does refresh the Redmine user attributes from the LDAP attributes every time the user logs in. In either case, Redmine reads the LDAP fields,
but never updates them.
#22 - 2009-08-25 01:20 - Florian Collot
Felix Schéafer wrote:
| think you got it backwards.Vanilla Redmine fetches information from LDAP only to populate some or all of the fields of a user at creation time,

the patch does refresh the Redmine user attributes from the LDAP attributes every time the user logs in. In either case, Redmine reads the
LDAP fields, but never updates them.

Thanks to your quick answer !
your project is really beautiful even though at present it is not possible to update the Active Directory entries :-) It doesn't matter, and it may be better
so that users cannot update their informations themselves

Thx !

#23 - 2009-08-25 01:20 - Florian Collot
- % Done changed from 90 to 100

Florian Collot wrote:
Felix Schafer wrote:

| think you got it backwards.Vanilla Redmine fetches information from LDAP only to populate some or all of the fields of a user at creation
time, the patch does refresh the Redmine user attributes from the LDAP attributes every time the user logs in. In either case, Redmine
reads the LDAP fields, but never updates them.

Thanks to your quick answer !
your project is really beautiful even though at present it is not possible to update the Active Directory entries :-) It doesn't matter, and it may be
better so that users cannot update their informations themselves

Thx !

#24 - 2009-08-25 01:31 - Felix Schéfer

Florian Collot wrote:

Thanks to your quick answer !

Pas de probléme :-)

your project is really beautiful even though at present it is not possible to update the Active Directory entries :-) It doesn't matter, and it may be
better so that users cannot update their informations themselves

Well, | have a POC to read the user attributes from LDAP each time the user object is instantiated, so that they are always fresh, not only when the
user logs in, but that goes well over the intended use of the auth_source, so I'm not sure as what | should file it... I'll try to clean up the code and
update it against current trunk, and send a patch.

#25 - 2009-09-20 19:21 - insrc in

Hi,

Just wanted to thank you Daniel for your great patch | Thanks to this patch, my redmine install can now authenticate my users against my Idap server
which requires a TLS encrypted connection :-)

May i suggest however that requiring to check the START_TLS option and the LDAPS when using a start_tls connection is a little bit confusing.

As you know, LDAPS and start_tls are two different way to secure the connection to an Idap server. The LDAPS connection (which is a bit deprecated
i think) is negociated on port 636 of the Idap server while the START_TLS connection occurs on the usual 389 port. See
http://www.openldap.org/fag/data/cache/185.html

So i think that those two options should be mutually exclusive :-)
HTH,

#26 - 2009-09-24 00:41 - david gurba

| work for an edu and have a local department Idap, and campus wide Idap. | have the 2 setup currently and can login via each LDAP instance, thank
you.

(1) How hard would it be to provide a drop down list to allow the user to select the LDAP source to authenticate against?
(2) ... Ideally as a user authenticates the 1st time and Redmine creates their account on-the-fly in Redmine ... | would the Admin to insert them into
given projects then email them that their account is setup fully ...

If given a bit of pointers | hope | could create the patch for at least (1) above ... any feedback is appreciated.

regards,
David

#27 - 2010-02-18 01:33 - Eric Davis
- Category changed from Accounts / authentication to LDAP

- % Done changed from 100 to 0

#28 - 2010-05-25 16:31 - Anthony Paul

Daniel Marczisovszky wrote:

ability to select protocol LDAPv2 or LDAPv3

connect using STARTTLS

selecting server certificate validation level

user-definable custom search filter

bind as current user instead of admin account, see Feature #1913

searching is sub-tree by default, in future GUI option may be added to configure this

Yes, it would be great to see this implemented in a next release, it would avoid to manually change the LDAP filter in app/models/auth_source_ldap.rb
everytime a new release appears...

#29 - 2011-03-20 23:07 - Etienne Massip

- Target version set to Candidate for next major release

#30 - 2011-08-11 17:15 - Dominik s

Anyone has a working patch for the latest trunk? We need TLS support but the patch is for a pretty old version of Redmine.

#31 - 2011-08-12 02:01 - Anonymous
- File advanced_Idap_auth 1.2.1.diff added
- File advanced_Ildap_auth r6417.diff added

Updated patch of Daniel Marczisovszky to current version of redmine (1.2.1) and current trunk revision (r6417).
Also added german translations of new fields in settings form.

#32 - 2011-12-08 00:04 - seb rey

Giinter Dressel wrote:

Updated patch of Daniel Marczisovszky to current version of redmine (1.2.1) and current trunk revision (r6417).
Also added german translations of new fields in settings form.

Do you think i can try to apply this patch on 1.2.2 stable redmine installation, anybody try ?
After that, can i have problem in the future to upgrade my installation ?
Thanks

#33 - 2011-12-09 15:34 - Anonymous

You can try - of course :)

| have to mention that | run into one little problem once | tried to apply my updated patch to another instance of redmie.
It was about that one LDAP property was forgotten to overwrite (One line of code, it's about STARTTLS vs. classic TLS)
If you are not trying to connect via STARTTLS you will not experience a problem at all.

And yes - it would lead to inconveniences for further upgrades, since you patch the core files.
You'll need to patch those files after each upcomming upgrade again.

If you are still looking forward to test it, I'm willing to support you with further testing on 1.2.2

Regards,
gue

#34 - 2011-12-09 20:06 - seb rey

Gunter Dressel wrote:
You can try - of course :)

(-]

If you are still looking forward to test it, I'm willing to support you with further testing on 1.2.2

Regards,
gue

I try to patch my 1.2.2 version, i have no error when patching, but after that, redmine crash with error :

[ pid=8941 thr=-609826598 file=utils.rb:176 time=2011-12-09 20:01:03.799 ]: *** Exception PhusionPassenger::UnknownError in
PhusionPassenger::ClassicRails::ApplicationS

pawner (no such file to load -- Idap (MissingSourceFile)) (process 8941, thread #<Thread:0xb74d91b4>):

from /usr/local/lib/site_ruby/1.8/rubygems/custom_require.rb:36:in "gem_original_require'

from /usr/local/lib/site_ruby/1.8/rubygems/custom_require.rb:36:in “require’

from /usr/lib/ruby/gems/1.8/gems/activesupport-2.3.11/lib/active_support/dependencies.rb:184:in “require’

from /var/www/redmine/app/models/auth_source_ldap.rb:20

Thanks for your help
SR.

#35 - 2011-12-09 20:22 - seb rey

I install libldap with apt-get install libldap-ruby1.8, and after i rake,
i have successful connection when i test in Idap_authentification, but when i try to enter a user + pass, i cannot login ...

#36 - 2011-12-09 22:44 - seb rey
- File Idap.png added
- File logldap.txt added

OK, after many test, i attach the png of my configuration, and a txt file with log of the "test" button on Idap auth page.
When i try to enter a login and password on login page, i have no debug in the log file of slapd, so ... ?

#37 - 2012-05-16 15:01 - H Cartiaux

Is it still needed for redmine 2.0.0 ? somebody has already tested this patch with 1.4.x or 2.0.0 ?

#38 - 2012-05-16 15:07 - Jérémy Lal

Especially considering ruby-net-ldap is now 0.3.1

#39 - 2012-08-13 16:17 - Kouhei Sutou

The latest net-ldap (0.3.1) supports STARTTLS.
My patch for STARTTLS was merged three years ago.

#40 - 2013-01-16 11:10 - Daniel Felix
Hi,

any news on this? This could be very helpful for our windows users! :-)

#41 - 2013-03-20 15:39 - Dominik s

Any solutions to this? It is still not working with the latest version of Redmine. There is still no option to ignore the certificate check which is rather
important. Since the file structure changed a lot, the applied patches do not work anymore.

#42 - 2013-03-27 12:49 - Miodrag Milic

| think that redmine_ldap_sync should serve as a model how this should get implemented. Actually, why not merging code of the plugin (after review)
to the Redmine, as it works like a charm at the moment.

#43 - 2014-02-28 11:29 - Phil Weir
- File advanced_Ildap_auth 2.2.3.diff added

This is a quick fix to get STARTTLS working for 2.2.3, just an update of the most recent patch above. There isn't much point in doing too much work
on this patch, as moving back to Net::LDAP seems much more logical anyway, but until one of us gets a chance to rewrite it properly this should
restore the functionality for those who need it (like me).

Note that this does effectively remove some of the more recent improvements to Redmine LDAP, such as validating the LDAP filter, but should still do

what the original patch was intended to. This may be obvious to others, but you need LDAPS checked for STARTTLS to work with port 389 and, if
you are using an LDAP filter with Redmine 2, don't forget to add (&(uid=$login)...) to it.
#44 - 2014-03-27 12:09 - Fadi Asbih

Correct me if i am wrong, so StartTLS(389) for LDAP is not supported in the latest Release of redmine?

#45 - 2014-08-11 16:41 - Fadi Asbih
If you need to use StartTLS instead of SSL (PORT 689), just edit the file

/app/models/auth_source_ldap.rb

in Linie 135, replace simple_tIs with start_tls, save the file & restart Apache. Also under the LDAP web Interface settings check LDAPS with port

389,
StartTLS should work now!
tested on:
Redmine version 2.5.2.stable.13231
Ruby version 1.9.3-pl94 (2012-04-20) [x86_64-1inux]
Rails version 3.2.19
Environment production
Database adapter Mysqgl2

#46 - 2018-06-05 13:37 - Joachim Steinmetz
Please merge this patch into the repo or create a new patch to implement STARTTLS for LDAP.

Thanks.

#47 - 2018-09-13 15:59 - Holger Just
- Related to Patch #29606: Support self-signed LDAPS connections added

Files

advanced_ldap_auth_0.8.3.diff 9.93 KB 2009-05-13 Daniel Marczisovszky
advanced_ldap_auth_r2743.diff 10 KB 2009-05-13 Daniel Marczisovszky
07_ldap_update.patch 1.98 KB 2009-07-14 Jérémy Lal
07_ldap_sync.patch 2.67 KB 2009-07-14 Jérémy Lal
advanced_ldap_auth_1.2.1.diff 12.3 KB 2011-08-12 Anonymous
advanced_ldap_auth_r6417.diff 12.3 KB 2011-08-12 Anonymous
ldap.png 43.9 KB 2011-12-09 seb rey
logldap.txt 5.79 KB 2011-12-09 seb rey
advanced_ldap_auth_2.2.3.diff 13.3 KB 2014-02-28 Phil Weir
